import josx.platform.rcx.*;

public abstract class AbstractApplication implements Constants {

	public static Thread mainThread;

	public static Runtime runtime;
	
	private static boolean ackReceived = false;
	
	protected static byte otherRound = 0;

	public static boolean isACKReceived() {
		return ackReceived;
	}
	
	public static void setACKReceived(boolean newValue) {
		ackReceived = newValue;
	}

	public AbstractApplication() {

		runtime = Runtime.getRuntime();

		mainThread = Thread.currentThread();

		// play start sound
		try {
			Thread.sleep(1000);
		} catch (InterruptedException e) {
		}

		// set the motor power to the highest level
		Motor.A.setPower(7);
		Motor.C.setPower(7);

		Serial.setRangeLong();
		
		Button.RUN.addButtonListener(new ButtonListener() {

			public void buttonPressed(Button b) {

			}

			public void buttonReleased(Button b) {

				mainThread.interrupt();
			}

		});

	}

	public static void move(byte dir) {
		
		if (dir == LEFT) { // left turn
			Motor.A.backward();
			Motor.C.forward();

		} else if (dir == RIGHT) { // right turn
			Motor.A.forward();
			Motor.C.backward();
		} else if (dir == FORWARD) { // move forward
			Motor.A.forward();
			Motor.C.forward();
		} else if (dir == STOP) {
			stopMoving();
		} else if (dir == SMOOTH_STOP) {
			smoothStop();
		} else if (dir == BACKWARD) {
			Motor.A.backward();
			Motor.C.backward();
		}

	}

	private static void stopMoving() {
		Motor.A.stop();
		Motor.C.stop();
	}

	private static void smoothStop() {
		Motor.A.flt();
		Motor.C.flt();
	}
	
}
