import josx.platform.rcx.*;

public class LineSeek extends Thread implements Constants {

	private boolean seeking = false;

	private boolean waiting = false;
	
	public LineSeek(Thread mainThread) {
		setDaemon(true);
	}

	public synchronized void startSeeking() {

		if (seeking || !waiting)
			return;
		
		seeking = true;

		synchronized (this) {
			notify();
		}

	}

	public synchronized void stopSeeking() {

		if (!seeking || waiting)
			return;

		seeking = false;
		
		interrupt();
	}
	
	public synchronized boolean isSeeking() {
		return seeking;
	}

	public void run() {

		while (true) {
			try {
				synchronized (this) {
					waiting = true;
					wait();
					waiting = false;

				}
			} catch (InterruptedException e1) {
				// sollte nie ausgef?hrt werden
				try {
					Thread.sleep(3000);
				} catch (InterruptedException e) {
				}
				AbstractApplication.mainThread.interrupt();
			}
			try {
				algorithm();
				seeking = false;
				LightSensorListener.greenFound();
			} catch (InterruptedException e) {
				ProducerApplication.move(FORWARD);
			}
		}

	}

	private byte lastDirection = LEFT;
	
	private static float factor;
	
	public static void setFactor(int t1, int t2) {
		
		factor = (float)t1 / t2;
		
		try {
			LCD.showNumber((int) (factor * 100));
			Thread.sleep(1000);
		} catch (InterruptedException e) {
		}
	}
	
	public static float getFactor() {
		return factor;
	}
	
	private short getRealSec(short direction, short sec) {
		
		// calculate duration in dependence of real motor power
		sec = (direction == LEFT) ? (short)(factor * sec) : sec;
		
		// add time for motors to change direction
		return (short)(sec + 30); 
	}

	private void algorithm() throws InterruptedException {

		// stop motors
		ProducerApplication.move(STOP);
		//short s = MoveHistory.getPredictedMove();
		Thread.sleep(25);

		// turn to left and then to right and then to the left and then...
		short sec = 100;
		short realsec = 0;
		byte direction = lastDirection;
		for (byte i = 0; i < 4; i++) {

			// turn to last direction
			ProducerApplication.move(direction);

			realsec = getRealSec(direction, sec);

			lastDirection = direction;
			Thread.sleep(realsec);

			// other direction for next try
			direction *= -1;
			sec *= 2;
			ProducerApplication.move(STOP);
			Thread.sleep(25);
		}
			
		ProducerApplication.move(direction);
		Thread.sleep(getRealSec(direction, (short)500));
		direction *= -1;
		ProducerApplication.move(STOP);
		Thread.sleep(25);

	}

}
