import josx.platform.rcx.*;

public class ProducerApplication extends AbstractApplication {

	public ProducerApplication() throws InterruptedException {

		super();

		LightSensorListener.init(Sensor.S2);

		Thread.sleep(1000);

		move(LEFT);
		while (LightSensorListener.getColor() == BLACK);

		int t1 = (int) System.currentTimeMillis();
		while (LightSensorListener.getColor() != BLACK);
		
		t1 = (int) System.currentTimeMillis() - t1;

		move(RIGHT);
		while (LightSensorListener.getColor() == BLACK);

		int t2 = (int) System.currentTimeMillis();
		while (LightSensorListener.getColor() != BLACK);
		
		t2 = (int) System.currentTimeMillis() - t2;

		move(STOP);

		LineSeek.setFactor(t1, t2);

		// initialise S2
		new LightSensorListener(Thread.currentThread());

		// start moving forward
		move(FORWARD);
		while (!Thread.interrupted())
			;

		move(STOP);

	}
	
	public static void main(String[] args) throws InterruptedException {
		new ProducerApplication();
	}

	public static void waitForBert() {
		
		LightSensorListener.setEnabled(false);
		
		while (true) {
		
			while(!Serial.isPacketAvailable());
		
			byte[] b = {0,0};		 
		
			Serial.readPacket(b);
		
			if (b[1] == 23)
				{
				 Sound.beepSequence();
				
				 LightSensorListener.setEnabled(true);
				 
				 return;		
				}
		
		}
		
	}

}
